<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ospi2urdf: comparison_pin_urdf_os_osim Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ospi2urdf
   </div>
   <div id="projectbrief">Express .osim files as .urdf files.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">comparison_pin_urdf_os_osim Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a3252947c25c034633f25884d92f35d7b"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a3252947c25c034633f25884d92f35d7b">changeFloating</a> (osim_rpy, L_os)</td></tr>
<tr class="memdesc:a3252947c25c034633f25884d92f35d7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Express the rotation matrix of a .osim free flyer joint into the .urdf global referential.  <a href="#a3252947c25c034633f25884d92f35d7b">More...</a><br /></td></tr>
<tr class="separator:a3252947c25c034633f25884d92f35d7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3806830267b9b8183efed1c1d6307ed1"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a3806830267b9b8183efed1c1d6307ed1">checkFreeFlyer</a> (vec)</td></tr>
<tr class="memdesc:a3806830267b9b8183efed1c1d6307ed1"><td class="mdescLeft">&#160;</td><td class="mdescRight">(Not used anymore).  <a href="#a3806830267b9b8183efed1c1d6307ed1">More...</a><br /></td></tr>
<tr class="separator:a3806830267b9b8183efed1c1d6307ed1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adcdc809bc3f370829d7fad3c0ee5799c"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#adcdc809bc3f370829d7fad3c0ee5799c">findGroundJointId</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>)</td></tr>
<tr class="memdesc:adcdc809bc3f370829d7fad3c0ee5799c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Short method to get the ground joint index of a Pinocchio model based on a .osim model.  <a href="#adcdc809bc3f370829d7fad3c0ee5799c">More...</a><br /></td></tr>
<tr class="separator:adcdc809bc3f370829d7fad3c0ee5799c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f737bea98a7bd0f9ad415df0bcfc477"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a6f737bea98a7bd0f9ad415df0bcfc477">getDoc</a> (obj)</td></tr>
<tr class="memdesc:a6f737bea98a7bd0f9ad415df0bcfc477"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get and print all the documentation of a Pinocchio object.  <a href="#a6f737bea98a7bd0f9ad415df0bcfc477">More...</a><br /></td></tr>
<tr class="separator:a6f737bea98a7bd0f9ad415df0bcfc477"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86f2ad5b7c261d509e7959f01e0be354"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a86f2ad5b7c261d509e7959f01e0be354">getJointAxis</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>)</td></tr>
<tr class="memdesc:a86f2ad5b7c261d509e7959f01e0be354"><td class="mdescLeft">&#160;</td><td class="mdescRight">(Not used anymore).  <a href="#a86f2ad5b7c261d509e7959f01e0be354">More...</a><br /></td></tr>
<tr class="separator:a86f2ad5b7c261d509e7959f01e0be354"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa123e107e1d77c8eecef3f5d561f0087"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa123e107e1d77c8eecef3f5d561f0087">IKOsimFKURDF</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">OS_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a949882fb90c3cc32bf3838b0c622a6c5">D_parts_urdf</a>, verbose=False)</td></tr>
<tr class="memdesc:aa123e107e1d77c8eecef3f5d561f0087"><td class="mdescLeft">&#160;</td><td class="mdescRight">Do Inverse Kinematics on the .osim model thanks to the parameters saved into the OsimModel object, check if the .urdf model can reach the joint positions with Forward Dynamics.  <a href="#aa123e107e1d77c8eecef3f5d561f0087">More...</a><br /></td></tr>
<tr class="separator:aa123e107e1d77c8eecef3f5d561f0087"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2d39b60256af364a533a45f7fba0444"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#ad2d39b60256af364a533a45f7fba0444">moveListJoint</a> (Lname, Lcons, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a>, verbose=False)</td></tr>
<tr class="memdesc:ad2d39b60256af364a533a45f7fba0444"><td class="mdescLeft">&#160;</td><td class="mdescRight">Given a list of joints name Lname, a list of constraints to be reached Lcons, a Pinocchio model urdf_model and its associated data object urdf_data, execute an Inverse Kinematic operation in order to determine the configuration q to reach the constraints, if these constraints can be achieved.  <a href="#ad2d39b60256af364a533a45f7fba0444">More...</a><br /></td></tr>
<tr class="separator:ad2d39b60256af364a533a45f7fba0444"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9638b1261922fce81ce9076584e60f61"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a9638b1261922fce81ce9076584e60f61">os2pi_Dpos</a> (D_osim, Meth=1)</td></tr>
<tr class="memdesc:a9638b1261922fce81ce9076584e60f61"><td class="mdescLeft">&#160;</td><td class="mdescRight">Take position dictionnaries expressed in osim referential, and express them into .urdf referential.  <a href="#a9638b1261922fce81ce9076584e60f61">More...</a><br /></td></tr>
<tr class="separator:a9638b1261922fce81ce9076584e60f61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d282f6b3a6f7c3e8bd572e4e8cea28e"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a3d282f6b3a6f7c3e8bd572e4e8cea28e">printConfig</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a>)</td></tr>
<tr class="memdesc:a3d282f6b3a6f7c3e8bd572e4e8cea28e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Displays the position and orientation of each of the joints of the .urdf model, expressed into the global referential associated with the .urdf.  <a href="#a3d282f6b3a6f7c3e8bd572e4e8cea28e">More...</a><br /></td></tr>
<tr class="separator:a3d282f6b3a6f7c3e8bd572e4e8cea28e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af14b1f481b3b2aeabee46c8bd9f419b1"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#af14b1f481b3b2aeabee46c8bd9f419b1">printQ</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, q)</td></tr>
<tr class="memdesc:af14b1f481b3b2aeabee46c8bd9f419b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Displays the value of each of the articulations of the .urdf model.  <a href="#af14b1f481b3b2aeabee46c8bd9f419b1">More...</a><br /></td></tr>
<tr class="separator:af14b1f481b3b2aeabee46c8bd9f419b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a050b1a1568ad22f1d736465376440787"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a050b1a1568ad22f1d736465376440787">QOsimToQURDF</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">OS_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a949882fb90c3cc32bf3838b0c622a6c5">D_parts_urdf</a>, lim_err=1e-6, verbose=False)</td></tr>
<tr class="memdesc:a050b1a1568ad22f1d736465376440787"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method used to apply the configuration of a given OsimModel to the .urdf model from which it is derived.  <a href="#a050b1a1568ad22f1d736465376440787">More...</a><br /></td></tr>
<tr class="separator:a050b1a1568ad22f1d736465376440787"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a592876ff20cfe9bb75d3c170e297ddbf"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a592876ff20cfe9bb75d3c170e297ddbf">staticDifference</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">OS_model</a>, lim_err=1e-6, verbose=False)</td></tr>
<tr class="memdesc:a592876ff20cfe9bb75d3c170e297ddbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks that the placement of joints (w.r.t each of them and then w.r.t world) of the .urdf model is consistent with that of the .osim model from which it is derived.  <a href="#a592876ff20cfe9bb75d3c170e297ddbf">More...</a><br /></td></tr>
<tr class="separator:a592876ff20cfe9bb75d3c170e297ddbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a744af0a31d02fed4a466a6ba649361cc"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a744af0a31d02fed4a466a6ba649361cc">testDynamicModel</a> (<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">OS_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a949882fb90c3cc32bf3838b0c622a6c5">D_parts_urdf</a>, <a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a5cd81f15cdc9a8c2df4c5299727855ca">ntry</a>=5, lim_err=1e-6, verbose=False)</td></tr>
<tr class="memdesc:a744af0a31d02fed4a466a6ba649361cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Carries out a series of tests to check that the .urdf model conforms to the .osim model.  <a href="#a744af0a31d02fed4a466a6ba649361cc">More...</a><br /></td></tr>
<tr class="separator:a744af0a31d02fed4a466a6ba649361cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a949882fb90c3cc32bf3838b0c622a6c5"><td class="memItemLeft" align="right" valign="top">dictionary&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a949882fb90c3cc32bf3838b0c622a6c5">D_parts_urdf</a> = {}</td></tr>
<tr class="memdesc:a949882fb90c3cc32bf3838b0c622a6c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Dictionary containing, for each joint name of the .urdf model, its joint parent index, the joint object associated with this name, and the placement of the joint in the referential of its parent joint.  <a href="#a949882fb90c3cc32bf3838b0c622a6c5">More...</a><br /></td></tr>
<tr class="separator:a949882fb90c3cc32bf3838b0c622a6c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9943cdc47fcab4aaa9250f232906cba0"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a9943cdc47fcab4aaa9250f232906cba0">geometry_path</a> = &quot;/home/auctus/Documents/OpenSim/4.2-2020-11-24-d9c8bb2c/Models/SimulationDataAndSetupFiles-4.0/Geometry&quot;</td></tr>
<tr class="memdesc:a9943cdc47fcab4aaa9250f232906cba0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Path to the .vtp files associated with the .osim model.  <a href="#a9943cdc47fcab4aaa9250f232906cba0">More...</a><br /></td></tr>
<tr class="separator:a9943cdc47fcab4aaa9250f232906cba0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf06840bb7321db3b08b1b60a3792784"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aaf06840bb7321db3b08b1b60a3792784">ik_path</a> = '/home/auctus/opensim_python/OpenSim/XML'</td></tr>
<tr class="memdesc:aaf06840bb7321db3b08b1b60a3792784"><td class="mdescLeft">&#160;</td><td class="mdescRight">Path to the folder containing Inverse Kinematics configuration file.  <a href="#aaf06840bb7321db3b08b1b60a3792784">More...</a><br /></td></tr>
<tr class="separator:aaf06840bb7321db3b08b1b60a3792784"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abcee81bb965d20f90e0976ea8eb7eb8f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#abcee81bb965d20f90e0976ea8eb7eb8f">max_err</a> = -1</td></tr>
<tr class="memdesc:abcee81bb965d20f90e0976ea8eb7eb8f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Maximum error output of the staticDifference method.  <a href="#abcee81bb965d20f90e0976ea8eb7eb8f">More...</a><br /></td></tr>
<tr class="separator:abcee81bb965d20f90e0976ea8eb7eb8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cd81f15cdc9a8c2df4c5299727855ca"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a5cd81f15cdc9a8c2df4c5299727855ca">ntry</a> = 100</td></tr>
<tr class="memdesc:a5cd81f15cdc9a8c2df4c5299727855ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of random tests that should be executed.  <a href="#a5cd81f15cdc9a8c2df4c5299727855ca">More...</a><br /></td></tr>
<tr class="separator:a5cd81f15cdc9a8c2df4c5299727855ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b2cdeddc2e39b6afd75bb7f97bcc5dc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">OS_model</a> = <a class="el" href="classpyopsim_1_1OsimModel.html">pyopsim.OsimModel</a>(<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a6b6825c194e9b3e049311a24acd2f504">osim_filename</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a9943cdc47fcab4aaa9250f232906cba0">geometry_path</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aaf06840bb7321db3b08b1b60a3792784">ik_path</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a71b8e400cb53841923f199a292963b80">setup_ik_file</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a51789b56e7ee8adcfa2d6d201380191a">trc_path</a>)</td></tr>
<tr class="memdesc:a2b2cdeddc2e39b6afd75bb7f97bcc5dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor of the OsimModel class.  <a href="#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">More...</a><br /></td></tr>
<tr class="separator:a2b2cdeddc2e39b6afd75bb7f97bcc5dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b6825c194e9b3e049311a24acd2f504"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a6b6825c194e9b3e049311a24acd2f504">osim_filename</a> = '/home/auctus/ospi2urdf/models/whole_body/wholebody.osim'</td></tr>
<tr class="memdesc:a6b6825c194e9b3e049311a24acd2f504"><td class="mdescLeft">&#160;</td><td class="mdescRight">Complete path to the .osim file (path + .osim file)  <a href="#a6b6825c194e9b3e049311a24acd2f504">More...</a><br /></td></tr>
<tr class="separator:a6b6825c194e9b3e049311a24acd2f504"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71b8e400cb53841923f199a292963b80"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a71b8e400cb53841923f199a292963b80">setup_ik_file</a> = &quot;Walk_Mkrs_IK.xml&quot;</td></tr>
<tr class="memdesc:a71b8e400cb53841923f199a292963b80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name of the Inverse Kinematics configuration file.  <a href="#a71b8e400cb53841923f199a292963b80">More...</a><br /></td></tr>
<tr class="separator:a71b8e400cb53841923f199a292963b80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a51789b56e7ee8adcfa2d6d201380191a"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a51789b56e7ee8adcfa2d6d201380191a">trc_path</a> = '/home/auctus/opensim_python/OpenSim/TRC/Walk_Mkrs.trc'</td></tr>
<tr class="memdesc:a51789b56e7ee8adcfa2d6d201380191a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Path to a trc file associated with the .osim file.  <a href="#a51789b56e7ee8adcfa2d6d201380191a">More...</a><br /></td></tr>
<tr class="separator:a51789b56e7ee8adcfa2d6d201380191a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a442eba16923825e1fef6f9b6135cc0b5"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a442eba16923825e1fef6f9b6135cc0b5">urdf_data</a> = urdf_model.createData()</td></tr>
<tr class="memdesc:a442eba16923825e1fef6f9b6135cc0b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pinocchio object containing all the values of the loaded URDF model which are the result of a computation.  <a href="#a442eba16923825e1fef6f9b6135cc0b5">More...</a><br /></td></tr>
<tr class="separator:a442eba16923825e1fef6f9b6135cc0b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70071ca4064db762f822331f4ace366c"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a70071ca4064db762f822331f4ace366c">urdf_filename</a> = &quot;/home/auctus/catkin_ws/src/human_control/description/wholebody/wholebody_aCol.urdf&quot;</td></tr>
<tr class="memdesc:a70071ca4064db762f822331f4ace366c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Complete path to the .urdf file (path + .urdf file)  <a href="#a70071ca4064db762f822331f4ace366c">More...</a><br /></td></tr>
<tr class="separator:a70071ca4064db762f822331f4ace366c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa61b9ef8f0749b6627e481cc5b62ed57"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aa61b9ef8f0749b6627e481cc5b62ed57">urdf_model</a> = se3.buildModelFromUrdf(<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a70071ca4064db762f822331f4ace366c">urdf_filename</a>)</td></tr>
<tr class="memdesc:aa61b9ef8f0749b6627e481cc5b62ed57"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pinocchio object containing all the physical description of the loaded URDF model.  <a href="#aa61b9ef8f0749b6627e481cc5b62ed57">More...</a><br /></td></tr>
<tr class="separator:aa61b9ef8f0749b6627e481cc5b62ed57"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a3252947c25c034633f25884d92f35d7b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3252947c25c034633f25884d92f35d7b">&#9670;&nbsp;</a></span>changeFloating()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.changeFloating </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>osim_rpy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>L_os</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Express the rotation matrix of a .osim free flyer joint into the .urdf global referential. </p>
<p>This transformation is slightly different from the classic ones, and depends on the order of the rotation axes of the .osim file. This order is expressed thanks to the list L_os.</p>
<h2>Parameters </h2>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">osim_rpy</td><td>: List. Roll, pitch, yaw angles of the .osim free flyer joint, expressed into the .osim global referential.</td></tr>
    <tr><td class="paramname">L_os</td><td>: List Order of x-axis, y-axis and z-axis expressed into the .osim file. Example : L_os = [2,0,1] : the order is then [z-axis,x-axis,y-axis] which means that the angles are [yaw,roll,pitch].</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>R_urdf : numpy.array (3x3) Rotation angles of the free flyer .osim joint expressed into the .urdf referential. </dd></dl>

</div>
</div>
<a id="a3806830267b9b8183efed1c1d6307ed1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3806830267b9b8183efed1c1d6307ed1">&#9670;&nbsp;</a></span>checkFreeFlyer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.checkFreeFlyer </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>vec</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>(Not used anymore). </p>
<p>Check if the values of a free flyer joint (6 DOF without any limits) are correct or not.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vec</td><td>: numpy.array (7x1) Vector of the values of the free flyer joint, expressed as follows : [ x , y , z , q_x , q_y , q_z , q_s ] (with q a quaternion).</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>tst : Boolean. Indicates if the values are correct or not. </dd></dl>

</div>
</div>
<a id="adcdc809bc3f370829d7fad3c0ee5799c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adcdc809bc3f370829d7fad3c0ee5799c">&#9670;&nbsp;</a></span>findGroundJointId()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.findGroundJointId </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Short method to get the ground joint index of a Pinocchio model based on a .osim model. </p>
<p>The ground joint is the joint between the origin of the global referential and the root of the Pinocchio model.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>ground_joint_id : Int. The index of the Ground joint in the Pinocchio model. </dd></dl>

</div>
</div>
<a id="a6f737bea98a7bd0f9ad415df0bcfc477"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f737bea98a7bd0f9ad415df0bcfc477">&#9670;&nbsp;</a></span>getDoc()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.getDoc </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get and print all the documentation of a Pinocchio object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">obj</td><td>: A pinocchio object.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None </dd></dl>

</div>
</div>
<a id="a86f2ad5b7c261d509e7959f01e0be354"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a86f2ad5b7c261d509e7959f01e0be354">&#9670;&nbsp;</a></span>getJointAxis()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.getJointAxis </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>(Not used anymore). </p>
<p>Extract from a .urdf model the axis of each of its joints.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>L_axis : List of List List containing the axis of each of the joints of the .urdf_model, in the same order as the list names of the Pinocchio object urdf_model. Each element of the L_axis object is expressed as follows : L_axis = [x-component of the axis vector, y-component of the axis vector, z-component of the axis vector ]. </dd></dl>

</div>
</div>
<a id="aa123e107e1d77c8eecef3f5d561f0087"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa123e107e1d77c8eecef3f5d561f0087">&#9670;&nbsp;</a></span>IKOsimFKURDF()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.IKOsimFKURDF </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>OS_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>D_parts_urdf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>verbose</em> = <code>False</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Do Inverse Kinematics on the .osim model thanks to the parameters saved into the OsimModel object, check if the .urdf model can reach the joint positions with Forward Dynamics. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">OS_model</td><td>: pyopsim OsimModel class. pyopsim object containing all the necessary informations about the .osim model.</td></tr>
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">urdf_data</td><td>: Pinocchio data object. Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. (joint configuration, velocity, ...).</td></tr>
    <tr><td class="paramname">D_parts_urdf</td><td>: Dictionary of List. <pre class="fragment">Dictionary containing, for each joint name of the .urdf model, its joint
parent index, the joint object associated with this name, and the placement
of the joint in the referential of its parent joint. 
An element of this dictionary is expressed as follows : 

    D_parts_urdf[joint name] = [ index of the parent joint, 
                                Pinocchio joint object associated with the joint name,
                                placement of the joint in the referential of its parent joint ]
</pre></td></tr>
    <tr><td class="paramname">verbose</td><td>: Boolean. Activate the print functions of the algorithm. Useful for debugging. The default is False.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>max_err : float. The maximal error encountered during the verification process. </dd></dl>

</div>
</div>
<a id="ad2d39b60256af364a533a45f7fba0444"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad2d39b60256af364a533a45f7fba0444">&#9670;&nbsp;</a></span>moveListJoint()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.moveListJoint </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>Lname</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>Lcons</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>verbose</em> = <code>False</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Given a list of joints name Lname, a list of constraints to be reached Lcons, a Pinocchio model urdf_model and its associated data object urdf_data, execute an Inverse Kinematic operation in order to determine the configuration q to reach the constraints, if these constraints can be achieved. </p>
<p>A message is displayed if those constraints are achieved,</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">Lname</td><td>: List. <pre class="fragment">List of the name of the joints on which the Inverse Kinematics operation is to be applied.
</pre></td></tr>
    <tr><td class="paramname">Lcons</td><td>: List of list. <pre class="fragment">List of the constraint to be reached by the selected joints.
One element is organized as follows : 
[ Rotation matrix, Position matrix ]
Example : 
[  se3.utils.rotate('x',3.0)  , np.array([0.08, -0.07, 0.86]) ]
</pre></td></tr>
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">urdf_data</td><td>: Pinocchio data object. Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. (joint configuration, velocity, ...).</td></tr>
    <tr><td class="paramname">verbose</td><td>: Boolean. Activate the print functions of the algorithm. Useful for debugging. The default is False.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>q : numpy.array Vector Q from the Inverse Kinematics operation.</dd>
<dd>
urdf_data : Pinocchio data object. The pinocchio data object updated so the joints have the values set in the Q vector.</dd>
<dd>
err : numpy.array (6 x number_of_joints, ) Final error vector between current and desired joints values. </dd></dl>

</div>
</div>
<a id="a9638b1261922fce81ce9076584e60f61"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9638b1261922fce81ce9076584e60f61">&#9670;&nbsp;</a></span>os2pi_Dpos()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.os2pi_Dpos </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>D_osim</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>Meth</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Take position dictionnaries expressed in osim referential, and express them into .urdf referential. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">D_osim</td><td>: Dictionnary of List. <pre class="fragment">Dictionary containing, for each name, the rotation and position
matrix expressed in the global referential of the .osim file.

The dictionary is organized as follows :

D_osim[name] = [ Position matrix, Rotation matrix ]
</pre></td></tr>
    <tr><td class="paramname">Meth</td><td>: Int, optionnal. Method chosen to express the rotation matrix from the .osim referential to the .urdf referential.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>D_urdf : Dictionnary of List. <pre class="fragment">Dictionary containing, for each name, the rotation and position
matrix expressed in the global referential of the .urdf file.

The format of this dictionary is the same as the D_urdf dictionary.</pre> </dd></dl>

</div>
</div>
<a id="a3d282f6b3a6f7c3e8bd572e4e8cea28e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3d282f6b3a6f7c3e8bd572e4e8cea28e">&#9670;&nbsp;</a></span>printConfig()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.printConfig </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Displays the position and orientation of each of the joints of the .urdf model, expressed into the global referential associated with the .urdf. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">urdf_data</td><td>: Pinocchio data object. Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. (joint configuration, velocity, ...).</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None. </dd></dl>

</div>
</div>
<a id="af14b1f481b3b2aeabee46c8bd9f419b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af14b1f481b3b2aeabee46c8bd9f419b1">&#9670;&nbsp;</a></span>printQ()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.printQ </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>q</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Displays the value of each of the articulations of the .urdf model. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">q</td><td>: numpy.array Vector Q associated with the .urdf model.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None. </dd></dl>

</div>
</div>
<a id="a050b1a1568ad22f1d736465376440787"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a050b1a1568ad22f1d736465376440787">&#9670;&nbsp;</a></span>QOsimToQURDF()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.QOsimToQURDF </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>OS_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>D_parts_urdf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>lim_err</em> = <code>1e-6</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>verbose</em> = <code>False</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Method used to apply the configuration of a given OsimModel to the .urdf model from which it is derived. </p>
<p>Then, this method apply this configuration to the .urdf model and checks that the placement of joints (expressed into the global referential of the .urdf model) of the .urdf model is consistent with that of the .osim model.</p>
<p>To do so, get the position and the orientation of each of the joints of the .osim model, express those informations into the .urdf referential, and then compare those informations to the concerned joints of the .urdf model.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">OS_model</td><td>: pyopsim OsimModel class. pyopsim object containing all the necessary informations about the .osim model.</td></tr>
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">urdf_data</td><td>: Pinocchio data object. Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. (joint configuration, velocity, ...).</td></tr>
    <tr><td class="paramname">D_parts_urdf</td><td>: Dictionary of List. <pre class="fragment">Dictionary containing, for each joint name of the .urdf model, its joint
parent index, the joint object associated with this name, and the placement
of the joint in the referential of its parent joint. 
An element of this dictionary is expressed as follows : 

    D_parts_urdf[joint name] = [ index of the parent joint, 
                                Pinocchio joint object associated with the joint name,
                                placement of the joint in the referential of its parent joint ]
</pre></td></tr>
    <tr><td class="paramname">lim_err</td><td>: float, optional. Maximal authorized error between the position and orientation of a .osim joint and a .urdf joint. Otherwise, </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None. an error. The default is 1e-6.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">verbose</td><td>: Boolean. Activate the print functions of the algorithm. Useful for debugging. The default is False.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>max_err : float. The maximal error encountered during the verification process. </dd></dl>

</div>
</div>
<a id="a592876ff20cfe9bb75d3c170e297ddbf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a592876ff20cfe9bb75d3c170e297ddbf">&#9670;&nbsp;</a></span>staticDifference()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.staticDifference </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>OS_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>lim_err</em> = <code>1e-6</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>verbose</em> = <code>False</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks that the placement of joints (w.r.t each of them and then w.r.t world) of the .urdf model is consistent with that of the .osim model from which it is derived. </p>
<p>To do so, get the position and the orientation of each of the joints of the .osim model, express those informations into the .urdf referential, and then compare those informations to the concerned joints of the .urdf model.</p>
<p>First, this method checks the placement of the joints expressed into the the referential of their parent joint, then checks the placement of the joints expressed in the global referential for a neutral configuration of the Q vector (= all elements of the Q vector set to 0).</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">urdf_data</td><td>: Pinocchio data object. Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. (joint configuration, velocity, ...).</td></tr>
    <tr><td class="paramname">OS_model</td><td>: pyopsim OsimModel class. pyopsim object containing all the necessary informations about the .osim model.</td></tr>
    <tr><td class="paramname">lim_err</td><td>: float, optional. Maximal authorized error between the position and orientation of a .osim joint and a .urdf joint. Otherwise, returns an error. The default is 1e-6.</td></tr>
    <tr><td class="paramname">verbose</td><td>: Boolean. Activate the print functions of the algorithm. Useful for debugging. The default is False.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>max_err : float. The maximal error encountered during the verification process.</dd>
<dd>
D_parts_urdf : Dictionary of List. Dictionary containing, for each joint name of the .urdf model, its joint parent index, the joint object associated with this name, and the placement of the joint in the referential of its parent joint. An element of this dictionary is expressed as follows : <pre class="fragment">D_parts_urdf[joint name] = [ index of the parent joint, 
                            Pinocchio joint object associated with the joint name,
                            placement of the joint in the referential of its parent joint ]</pre> </dd></dl>

</div>
</div>
<a id="a744af0a31d02fed4a466a6ba649361cc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a744af0a31d02fed4a466a6ba649361cc">&#9670;&nbsp;</a></span>testDynamicModel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def comparison_pin_urdf_os_osim.testDynamicModel </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>OS_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>urdf_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>D_parts_urdf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>ntry</em> = <code>5</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>lim_err</em> = <code>1e-6</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>verbose</em> = <code>False</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Carries out a series of tests to check that the .urdf model conforms to the .osim model. </p>
<p>To do this, first test the positions of the joints at their extreme values, then check for a series of ntry of random configurations the positions of the joints of both models. Stop the verification if the maximum error of a configuration is superior to the value lim_err. In this case, displays the number of the test that failed, the configuration vector Q and the value of the error.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">OS_model</td><td>: pyopsim OsimModel class. pyopsim object containing all the necessary informations about the .osim model.</td></tr>
    <tr><td class="paramname">urdf_model</td><td>: Pinocchio model object. Pinocchio object containing all the physical description of the loaded URDF model, including kinematic and inertial parameters defining its structure. Please check <a href="https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html">https://gepettoweb.laas.fr/doc/stack-of-tasks/pinocchio/master/doxygen-html/md_doc_a-features_intro.html</a> for more informations.</td></tr>
    <tr><td class="paramname">urdf_data</td><td>: Pinocchio data object. Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. (joint configuration, velocity, ...).</td></tr>
    <tr><td class="paramname">D_parts_urdf</td><td>: Dictionary of List. Dictionary containing, for each joint name of the .urdf model, its joint parent index, the joint object associated with this name, and the placement of the joint in the referential of its parent joint. An element of this dictionary is expressed as follows : <pre class="fragment">D_parts_urdf[joint name] = [ index of the parent joint, 
                            Pinocchio joint object associated with the joint name,
                            placement of the joint in the referential of its parent joint ]
</pre></td></tr>
    <tr><td class="paramname">ntry</td><td>: Int, optional. Number of random tests that should be executed. The default is 5.</td></tr>
    <tr><td class="paramname">lim_err</td><td>: float, optional Maximal authorized error between the position and orientation of a .osim joint and a .urdf joint for a configuration Q. Otherwise, </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None. an error. The default is 1e-6.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">verbose</td><td>: Boolean. Activate the print functions of the algorithm. Useful for debugging. The default is False.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None. </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a949882fb90c3cc32bf3838b0c622a6c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a949882fb90c3cc32bf3838b0c622a6c5">&#9670;&nbsp;</a></span>D_parts_urdf</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">D_parts_urdf = {}</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Dictionary containing, for each joint name of the .urdf model, its joint parent index, the joint object associated with this name, and the placement of the joint in the referential of its parent joint. </p>

</div>
</div>
<a id="a9943cdc47fcab4aaa9250f232906cba0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9943cdc47fcab4aaa9250f232906cba0">&#9670;&nbsp;</a></span>geometry_path</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string geometry_path = &quot;/home/auctus/Documents/OpenSim/4.2-2020-11-24-d9c8bb2c/Models/SimulationDataAndSetupFiles-4.0/Geometry&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Path to the .vtp files associated with the .osim model. </p>

</div>
</div>
<a id="aaf06840bb7321db3b08b1b60a3792784"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf06840bb7321db3b08b1b60a3792784">&#9670;&nbsp;</a></span>ik_path</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string ik_path = '/home/auctus/opensim_python/OpenSim/XML'</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Path to the folder containing Inverse Kinematics configuration file. </p>

</div>
</div>
<a id="abcee81bb965d20f90e0976ea8eb7eb8f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abcee81bb965d20f90e0976ea8eb7eb8f">&#9670;&nbsp;</a></span>max_err</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">max_err = -1</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Maximum error output of the staticDifference method. </p>

</div>
</div>
<a id="a5cd81f15cdc9a8c2df4c5299727855ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5cd81f15cdc9a8c2df4c5299727855ca">&#9670;&nbsp;</a></span>ntry</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int ntry = 100</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Number of random tests that should be executed. </p>

</div>
</div>
<a id="a2b2cdeddc2e39b6afd75bb7f97bcc5dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2b2cdeddc2e39b6afd75bb7f97bcc5dc">&#9670;&nbsp;</a></span>OS_model</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OS_model = <a class="el" href="classpyopsim_1_1OsimModel.html">pyopsim.OsimModel</a>(<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a6b6825c194e9b3e049311a24acd2f504">osim_filename</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a9943cdc47fcab4aaa9250f232906cba0">geometry_path</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#aaf06840bb7321db3b08b1b60a3792784">ik_path</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a71b8e400cb53841923f199a292963b80">setup_ik_file</a>,<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a51789b56e7ee8adcfa2d6d201380191a">trc_path</a>)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor of the OsimModel class. </p>

</div>
</div>
<a id="a6b6825c194e9b3e049311a24acd2f504"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b6825c194e9b3e049311a24acd2f504">&#9670;&nbsp;</a></span>osim_filename</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string osim_filename = '/home/auctus/ospi2urdf/models/whole_body/wholebody.osim'</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Complete path to the .osim file (path + .osim file) </p>

</div>
</div>
<a id="a71b8e400cb53841923f199a292963b80"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71b8e400cb53841923f199a292963b80">&#9670;&nbsp;</a></span>setup_ik_file</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string setup_ik_file = &quot;Walk_Mkrs_IK.xml&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Name of the Inverse Kinematics configuration file. </p>

</div>
</div>
<a id="a51789b56e7ee8adcfa2d6d201380191a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a51789b56e7ee8adcfa2d6d201380191a">&#9670;&nbsp;</a></span>trc_path</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string trc_path = '/home/auctus/opensim_python/OpenSim/TRC/Walk_Mkrs.trc'</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Path to a trc file associated with the .osim file. </p>

</div>
</div>
<a id="a442eba16923825e1fef6f9b6135cc0b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a442eba16923825e1fef6f9b6135cc0b5">&#9670;&nbsp;</a></span>urdf_data</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">urdf_data = urdf_model.createData()</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Pinocchio object containing all the values of the loaded URDF model which are the result of a computation. </p>

</div>
</div>
<a id="a70071ca4064db762f822331f4ace366c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a70071ca4064db762f822331f4ace366c">&#9670;&nbsp;</a></span>urdf_filename</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string urdf_filename = &quot;/home/auctus/catkin_ws/src/human_control/description/wholebody/wholebody_aCol.urdf&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Complete path to the .urdf file (path + .urdf file) </p>

</div>
</div>
<a id="aa61b9ef8f0749b6627e481cc5b62ed57"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa61b9ef8f0749b6627e481cc5b62ed57">&#9670;&nbsp;</a></span>urdf_model</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">urdf_model = se3.buildModelFromUrdf(<a class="el" href="namespacecomparison__pin__urdf__os__osim.html#a70071ca4064db762f822331f4ace366c">urdf_filename</a>)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Pinocchio object containing all the physical description of the loaded URDF model. </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
